<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';

  const props = withDefaults(
    defineProps<{
      data: Product;
      loading?: boolean;
    }>(),
    {
      loading: false,
    },
  );
  const product = computed(() => props.data);
  const productId = computed(() => props.data.id);
  const { quickViewModalController } = useQuickView();
  const { isGuide } = useUser();
  const { addToCart, loading: loadingAddToCart } = useAddToCart(product);
  const { isLiked, toggleLike, loading: loadingLike } = useLikeItem(productId);
  const { controlledClient } = useParticipants();

  const handleQuickView = () => {
    quickViewModalController.open(product.value.id);
  };

  const isMainProduct = computed(() => {
    return !!(
      product.value.parentId === null &&
      product.value.childCount &&
      product.value.childCount > 0
    );
  });
</script>
<template>
  <SwProductCard
    :loading="loading"
    :data="product"
    :is-main-product="isMainProduct"
    @click="handleQuickView"
  >
    <template #product-interact>
      <SwLikeButton
        class="!px-2"
        variant="action"
        :is-liked="isLiked"
        :loading="loadingLike"
        :disabled="isGuide && !controlledClient"
        @click="toggleLike"
      />
    </template>

    <template #product-action>
      <div class="flex gap-3">
        <SwButton
          v-if="isMainProduct"
          variant="action"
          size="large"
          class="w-full"
          @click="handleQuickView"
        >
          {{ $t('product.details') }}
        </SwButton>
        <SwButton v-else class="flex-1" :loading="loadingAddToCart" @click="addToCart()">
          <span class="i-sw-solid:shopping-cart mr-1 text-sm" />
          {{ $t('product.addToCart') }}
        </SwButton>
        <SwButton
          v-if="isGuide && !isMainProduct"
          class="aspect-square h-9"
          variant="action"
          @click="handleQuickView"
        >
          <template #icon>
            <span class="i-sw-solid:eye h-4 w-4" />
          </template>
        </SwButton>
      </div>
    </template>
  </SwProductCard>
</template>
